!(function () {
    var params = FR.generateUrlParam(window.location.href);
    var token_key = "fine_auth_token";
    var param_key = "__parameters__";
    var token;

    // url 直接传入
    !token && params.hasOwnProperty(token_key) && (token = params[token_key]);

    // 超级链接到模板
    if (!token) {
        var hp;
        try {
            if (params.hasOwnProperty(param_key) && (hp = JSON.parse(decodeURIComponent(decodeURIComponent(params[param_key])))).hasOwnProperty(token_key)) {
                token = hp[token_key];
            }
        } catch (e) {
            console.error(e);
        }
    }

    if (token) {
        console.log("Load fine_auth_token from parameter successful!");
        var _ajax = FR.ajax;
        FR.ajax = function (i) {
            i.data || ( i.data = {});
            i.data[token_key] = token;
            _ajax.call(this, i);
        };

        var _hyperLinkByGet = FR.doHyperlinkByGet4Reportlet;
        FR.doHyperlinkByGet4Reportlet = function (i) {
            i.para || ( i.para = {});
            i.para[token_key] = token;
            _hyperLinkByGet.call(this, i);
        };

        // 网页框
        let _changeIframe = FR.IframeEditor.prototype._changeIframe;
        FR.IframeEditor.prototype._changeIframe = function (src) {
            src += (((src.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
            _changeIframe.call(this, src);
        }

        // 网页框插件
        if (FR.RHIframe) {
            let _changeIframe = FR.RHIframe.prototype._changeIframe;
            FR.RHIframe.prototype._changeIframe = function (src) {
                src += (((src.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
                _changeIframe.call(this, src);
            }
        }

        // 导出请求
        var _openUrlByForm = FR.openUrlByForm;
        FR.openUrlByForm = function (src) {
            src += (((src.indexOf("?") > -1) ? "&":"?") + token_key + "=" + token);
            _openUrlByForm.call(this, src);
        }

    } else {
        console.log("Load fine_auth_token from parameter failed!");
    }

})();